/**
 * \file
 *
 * \brief UART荞ݗ
 *
 * 쌠 (C) 2016 Atmel Corporation. s
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 */
/*
 * xFAQ: <a href="http://www.atmel.com/design-support/">Atmelx</a>q˂ĂB
 */

#if __GNUC__
#include "avr/io.h"
#include "avr/interrupt.h"
#else
#include "ioavr.h"
#include <ina90.h>
#endif

#define UBRR_VAL	51

/* UARTɏՕ` */
#define UART_RX_BUFFER_SIZE 8		/* 2,4,8,16,32,64,128܂256޲*/
#define UART_TX_BUFFER_SIZE 8		/* 2,4,8,16,32,64,128܂256޲*/
#define UART_RX_BUFFER_MASK (UART_RX_BUFFER_SIZE - 1)

#if (UART_RX_BUFFER_SIZE & UART_RX_BUFFER_MASK)
	#error RX buffer size is not a power of 2	// MɏՕeʂ2ׂ̂ł܂B
#endif

#define UART_TX_BUFFER_MASK (UART_TX_BUFFER_SIZE - 1)
#if (UART_TX_BUFFER_SIZE & UART_TX_BUFFER_MASK)
	#error TX buffer size is not a power of 2	// MɏՕeʂ2ׂ̂ł܂B
#endif

/* ÓIϐ */
static unsigned char UART_RxBuf[UART_RX_BUFFER_SIZE];
static volatile unsigned char UART_RxHead;
static volatile unsigned char UART_RxTail;
static unsigned char UART_TxBuf[UART_TX_BUFFER_SIZE];
static volatile unsigned char UART_TxHead;
static volatile unsigned char UART_TxTail;

/* ^ */
void InitUART(unsigned char ubrr_val);
unsigned char ReceiveByte(void);
void TransmitByte(unsigned char data);

int main(void)
{
	InitUART(UBRR_VAL);		/* 8MHz RCUgp9800bpsްڰĐݒ */
	#if __GNUC__
		sei();				/* S̊荞݋(UART荞݋) */
	#else
		_SEI();				/* S̊荞݋(UART荞݋) */
	#endif

	for(;;) {				/* JԂ */
		TransmitByte(ReceiveByte());	/* MԂ */
	}
	return 0;
}

/* UART */
void InitUART(unsigned char ubrr_val)
{
	unsigned char x;

	UBRRH = (unsigned char)(ubrr_val>>8);	/* ްڰĐݒ */
	UBRRL = (unsigned char)ubrr_val;
	UCSRB = ((1<<RXEN) | (1<<TXEN) | (1<<RXCIE));	/* UARTMƎM荞݂ */

	x = 0;				/* ȉMɏՕ */
	UART_RxTail = x;	/* Mǂݍ݈ʒuwq */
	UART_RxHead = x;	/* M݈ʒuwq */
	UART_TxTail = x;	/* Mǂݍ݈ʒuwq */
	UART_TxHead = x;	/* M݈ʒuwq */
}

/* 荞ݏ */
#if __GNUC__
ISR(USART_RX_vect)
#else
#pragma vector=USART_RXC_vect
__interrupt void UART_RX_interrupt(void)
#endif
{
	unsigned char data;
	unsigned char tmphead;

	data = UDR;					/* Mް擾 */
	tmphead = (UART_RxHead + 1) & UART_RX_BUFFER_MASK;	/* MɏՕ݈ʒu擾 */
	UART_RxHead = tmphead;		/* MɏՕ݈ʒuwqXV */

	if (tmphead == UART_RxTail) {
		/* ُ! MɏՕ */
	}
	UART_RxBuf[tmphead] = data;	/* MɏՕɎMްi[ */
}

#if __GNUC__
ISR(USART_UDRE_vect)
#else
#pragma vector=USART_UDRE_vect
__interrupt void UART_TX_interrupt(void)
#endif

{
	unsigned char tmptail;

	if (UART_TxHead != UART_TxTail) {	/* MɏՕɑMްLŁA */
		tmptail = ( UART_TxTail + 1 ) & UART_TX_BUFFER_MASK;	/* MɏՕǂݍ݈ʒu擾 */
		UART_TxTail = tmptail;		/* MɏՕǂݍ݈ʒuwqXV */
		UDR = UART_TxBuf[tmptail];	/* MJn */
	} else {							/* MɏՕɑMްȂŁA */
		UCSRB &= ~(1<<UDRIE);		/* Mް ڼ޽󂫊荞݋֎~ */
	}
}

unsigned char ReceiveByte(void)
{
	unsigned char tmptail;

	while (UART_RxHead == UART_RxTail);	/* ް҂ */
	tmptail = (UART_RxTail + 1) & UART_RX_BUFFER_MASK;	/* MɏՕǂݍ݈ʒu擾 */
	UART_RxTail = tmptail;			/* MɏՕǂݍ݈ʒuwqXV */
	return UART_RxBuf[tmptail];		/* MɏՕ̎MްƋɕA */
}

void TransmitByte(unsigned char data)
{
	unsigned char tmphead;

	tmphead = (UART_TxHead + 1) & UART_TX_BUFFER_MASK;	/* MɏՕ݈ʒu擾 */
	while (tmphead == UART_TxTail);		/* MɏՕ󂫑҂ */
	UART_TxBuf[tmphead] = data;			/* MɏՕɑMްi[ */
	UART_TxHead = tmphead;				/* MɏՕ݈ʒuwqXV */
	UCSRB |= (1<<UDRIE);				/* Mް ڼ޽󂫊荞݋ */
}
